#include "StdAfx.h"
#include "CloseWindow.h"

#include <stdio.h>
#include <tchar.h>

CCloseWindow::CCloseWindow(void)
{
}


CCloseWindow::~CCloseWindow(void)
{
}


BOOL CCloseWindow::Init(HINSTANCE hmod, DWORD dwpid)
{
	// set process ID
	g_dwPid = dwpid;
	g_hInst = hmod;
	// set hook
	g_hHook = SetWindowsHookEx(WH_SHELL, CbtProc, hmod, NULL);
	if (!g_hHook) {
		return FALSE;
	}

	return TRUE;
}


BOOL CCloseWindow::Exit(void)
{
	// remove hook
	if (g_hHook)
		return UnhookWindowsHookEx(g_hHook);

	return TRUE;
}


LRESULT CALLBACK CCloseWindow::CbtProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	switch (nCode) {
		case HSHELL_LANGUAGE: {
			HWND hWnd = FindWindowEx(NULL, NULL, L"#32770", L"Open");
			if (hWnd) {
				SendMessage(hWnd, WM_CLOSE, NULL, NULL);
			}
			break;
		}
	}
	return CallNextHookEx(g_hHook, nCode, wParam, lParam);
}
