// PWBCloseWindow.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "PWBShellCloseWindow.h"


#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		DisableThreadLibraryCalls(hModule);
		g_hInstance = hModule;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

#ifdef _MANAGED
#pragma managed(pop)
#endif

// exported functions
PWBCLOSEWINDOW_API BOOL PWBAddonStart(LONGLONG hWindow)
{
	// set window handle
	g_dwHandle = (HWND)hWindow;
	// get process ID
	DWORD dwProcID;
	GetWindowThreadProcessId((HWND)hWindow, &dwProcID);
	WindowClose.Init(g_hInstance, dwProcID);
	return TRUE;
}

PWBCLOSEWINDOW_API BOOL PWBAddonEnd()
{
    WindowClose.Exit();
	return TRUE;
}
