// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the PWBCLOSEWINDOW_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// PWBCLOSEWINDOW_API functions as being imported from a DLL, whereas this DLL sees symbols
// defined with this macro as being exported.
#ifdef PWBCLOSEWINDOW_EXPORTS
#define PWBCLOSEWINDOW_API __declspec(dllexport)
#else
#define PWBCLOSEWINDOW_API __declspec(dllimport)
#endif

#include "CloseWindow.h"
#include <atlstr.h>



#pragma data_seg( ".PWBShellCloseWindow" )	// you must define as SHARED in .def

HMODULE g_hInstance = NULL;   // global instance handle
HWND g_dwHandle = NULL;
CCloseWindow WindowClose;

#pragma data_seg()
#pragma comment( linker, "/SECTION:.PWBShellCloseWindow,RWS" )

// exported functions
extern "C" PWBCLOSEWINDOW_API BOOL PWBAddonStart( LONGLONG hWindow );
extern "C" PWBCLOSEWINDOW_API BOOL PWBAddonEnd( void );
